class Signal {
    listeners = new Map();
    emit(args) {
        for (let l of this.listeners.values()) {
            l(args);
        }
    }
    // Add a dummy signal name to keep this signature compatible with GObjects:
    connect(signal, handler) {
        console.assert(signal === 'changed', 'The only supported signal for now is `changed`');
        let id = Date.now() + Math.random();
        this.listeners.set(id, handler);
        return id;
    }
    disconnect(id) {
        this.listeners.delete(id);
    }
}

export { Signal as default };
